﻿using System.Globalization;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.Core;

namespace ThinkGeo.MapSuite.WebEdition
{
    public class MapContainer : Panel, IPostBackEventHandler
    {
        public MapContainer()
        {

        }

        void IPostBackEventHandler.RaisePostBackEvent(string eventArgument)
        {
            string[] arguments = eventArgument.Split('^');
            string header = arguments[0];

            if (header == "SHOWPOPUP")
            {

                var map = GetMap();

                ScreenPointF screenPosition = new ScreenPointF(float.Parse(arguments[1], CultureInfo.InvariantCulture), float.Parse(arguments[2], CultureInfo.InvariantCulture));
                var poistion = ExtentHelper.ToWorldCoordinate(map.CurrentExtent, screenPosition, (float)map.WidthInPixels, (float)map.HeightInPixels);

                Popup childPopup = map.Popups["ChildPopup"];
                childPopup.IsVisible = true;


                childPopup.Position = poistion;
            }
        }

        private Map GetMap()
        {

            foreach (var control in Controls)
            {
                var map = control as Map;
                if (map != null)
                {
                    return map;
                }
            }
            return null;
        }
    }
}
